/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*************************************************************
*      myname           Semantic.h
*      created          9/3/1996
*      updated          9/12/1996
*      works            9/12/1996
*
*		designer		rrs/1996
*************************************************************/

/***********************************************************
*
*	               OPERATION OVERVIEW
*
*
************************************************************/
#ifndef _SEMANTIC_H
#define _SEMANTIC_H
/* Feature test switches */
#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif  /* _POSIX_SOURCE */

#if __STDC__ == 1
/*
 * The following macro definations take affect when compiling under ansi C
 *
 * The A_ macro is provided for function prototype declarations.  It allows
 * ANSI C prototypes to be complied under K&R C
 */

#define A_(x) x

#else
/* The following macro definations take affect when compiling under K&R C */

#define const
#define volatile
#define A_(x) ()

#endif  /* __STDC__ */

#include "SymTab.h"
 
/*prototypes*/
extern void
SemanticInit A_((void));

extern void
SemanticPutDF A_((int df));

extern void
SemanticCondPrint A_((char *str));

extern void
SemanticPrint A_((void));

extern void
SemanticErr A_((int e));

extern void
SemanticPrintToken2 A_((struct MYTOK symbol));

extern void
SemanticPutToken A_((struct MYTOK symbolp, char *lex, int lin, int len, int typ, int varFlag ));

extern void
SemanticStatNopCk A_((void));

extern void
SemanticStatPlusExprCk A_((struct MYTOK left_expr, struct MYTOK right_expr));

extern void
SemanticStatMinusExprCk A_((struct MYTOK left_expr, struct MYTOK right_expr));

extern void
SemanticStatMultDivExprCk A_((struct MYTOK left_expr, struct MYTOK right_expr));

extern void
SemanticStatModulusExprCk A_((struct MYTOK left_expr, struct MYTOK right_expr));

extern void
SemanticStatCompExprCk A_((struct MYTOK left_expr, struct MYTOK right_expr));

extern void
SemanticStatAndOrExprCk A_((struct MYTOK left_expr, struct MYTOK right_expr));

extern void
SemanticStatNotExprCk A_((struct MYTOK expr));

extern void
SemanticStatPostOpExprCk A_((struct MYTOK expr));

extern void
SemanticStatUnaryExprCk A_((struct MYTOK expr));

extern void
SemanticStatAssignCk A_((struct MYTOK var, struct MYTOK expr));

extern void
SemanticStatPrintTailCk A_((struct MYTOK exp));

extern void
SemanticStatWhileHeadCk A_((struct MYTOK exp));

extern void
SemanticStatIfHeadCk A_((struct MYTOK exp));

extern void
SemanticStatReturnTailCk A_((struct MYTOK exp));

extern void
SemanticStatForHeadCk A_((struct MYTOK exp6, struct MYTOK exp8));

extern void
SemanticStatForAssignCk A_((struct MYTOK exp1, struct MYTOK exp2));

extern void
SemanticStatForPostAssignCk A_((struct MYTOK exp));

extern void
SemanticStatForeachHeadCk A_((struct MYTOK val1, struct MYTOK val2));

extern void
SemanticVarDefCk A_((struct MYTOK var));

extern int
SemanticParamVarCk A_((struct MYTOK val));

extern int
SemanticParamConstsCk A_((struct MYTOK val));

extern void
SemanticCaseTypeCk A_((struct MYTOK val));

extern void
SemanticCaseInTypeCk A_((struct MYTOK val));

extern void
SemanticCaseInVarCk A_((struct MYTOK var));

extern void
SemanticTimeConstCk A_((struct MYTOK h, struct MYTOK m, struct MYTOK s));

extern void
SemanticDateConstCk A_((struct MYTOK m, struct MYTOK d, struct MYTOK y));

extern void
SemanticIntConstRangeCk A_((struct MYTOK lo, struct MYTOK hi));

extern void
SemanticFloatConstRangeCk A_((struct MYTOK lo, struct MYTOK hi));

extern void
SemanticDayofweekConstRangeCk A_((struct MYTOK lo, struct MYTOK hi));

extern void
SemanticDateTimeConstRangeCk A_((struct MYTOK lo, struct MYTOK hi));

extern void
SemanticSizeConstRangeCk A_((struct MYTOK lo, struct MYTOK hi));

#endif /* _SEMANTIC_H */
